#-------------------------------------------------------------------------------
# Name:        Calcu_Z/L_H
# Purpose:     Simulating the redox evolution of two locally oxidized environments in the Archean.
#
# Authors:      Hongping He, Xiao Wu, Haiyang Xian, Jianxi Zhu, YipingYang, Ying Lv, Yiliang Li, Kurt O. Konhauser

#
# Created:     03-09-2021
# Copyright:   (c) GIGCAS 2021
#-------------------------------------------------------------------------------
import os

Z = 2     #Depth to anoxic layer, cm
H = 1e-13      #peroxide, mol/cm3
dt = 0.001          #timestep, year
K = 6.3e2      #cm2/yr
Y = Z*H
Fa = 5.24e-7   #mol cm-2 yr-1
tau = 0.1       #yr
Fe = 1e-7       # mol cm-3
Velmax = Fa/Fe
##print(tau)

f = open("out.txt","w")
print("Z_initial=",Z,"cm",file=f)
print("H_initial=",H,"mol/mL",file=f)
print("K=",K,"cm2/yr",file=f)
print("Fa=",Fa,"mol cm-2 yr-1",file=f)
print("tau=",tau,"yr",file=f)
print("[time, yr]","[Depth to anoxic layer, m]","[peroxide, nmol/L]",file=f)
f.close()

i = 1
while i < 10000001:
    Vel = (K * H * 2/Z) / Fe
    Veluse = min(Vel,Velmax)
#    print(Veluse)
    Z = Z + dt*Veluse
    gamma = -(1/tau + 2*K/(Z*Z))
    Y = Y + dt*Fa*(1+gamma*Y)
    H = Y/Z
    m = i/1000
    t = i*dt
    Z1 = Z/100     #Depth to anoxic layer, convert unit to m
    H1 = H*1e12    #peroxide, convert unit to nnmol/L
#    print(i)
    aaa=str(m % 1 == 0)
##    print(aaa)
    if aaa == "True":
            f = open("out.txt","a+")
            print(t,Z1,H1,file=f)
            f.close()
    i += 1